<?php
/*
 * Created on 08.08.2007 - 23:10:43
 *
 * +-----------------------------------------+
 * | PHP version 5.1                         |
 * +-----------------------------------------+
 * | Copyright (c) 2007 Toby				 |
 * +-----------------------------------------+
 * | Authors: Tobias Friebel <TobyF@Web.de>  |
 * +-----------------------------------------+
 *
 * Project: TemperMeter
 *
 * $Id$
 */

require_once (WCF_DIR . 'lib/system/event/EventListener.class.php');

class TemperMeterListener implements EventListener
{
	public static $temper = -1;
	protected static $temperOption = array();
	
	/**
	 * @see EventListener::execute()
	 */
	public function execute($eventObj, $className, $eventName)
	{
		if (self :: $temper == -1)
			self :: $temper = WCF :: getUser()->temper;
			
		if (empty(self :: $temperOption))
		{
			self :: $temperOption = WCF::getCache()->get('user-option-' . PACKAGE_ID, 'options');
			self :: $temperOption = self :: $temperOption['temper'];
		}
		
		switch ($eventName)
		{
			case 'readFormParameters':
				if (isset($_POST['temper'])) 
				{
					self :: $temper = intval($_POST['temper']);
				}
			break;
			
			case 'validate':
				if (self :: $temperOption != -1) 
				{
					$options = OptionUtil :: parseSelectOptions(self :: $temperOption['selectOptions']);
					if (!isset($options[self :: $temper])) 
					{
						throw new UserInputException(self :: $temperOption['optionName'], 'validationFailed');
					}
				}
			break;
			
			case 'saved':
				$sql = "UPDATE 	wbb" . WBB_N . "_post
						SET 	temper = " . self :: $temper . "
						WHERE 	postID = ";
				
				if ($className == 'ThreadAddForm')
				{
					$sql .= $eventObj->newThread->firstPostID;
				}
				elseif ($className == 'PostEditForm')
				{
					$sql .= $eventObj->post->postID;
				}
				else
				{
					$sql .= $eventObj->newPost->postID;
				}
				
				$editor = WCF :: getUser()->getEditor();
				$editor->updateOptions(array (
					'temper' => self :: $temper
				));
				
				WCF :: getDB()->registerShutdownUpdate($sql);
			break;
			
			case 'assignVariables':
				if ($className == 'ThreadPage')
				{
					$data = array();

					$c = count($eventObj->postList->posts);
					for ($i = 0; $i < $c; $i++)
					{
						if ($eventObj->postList->posts[$i]->temper == 0)
							continue;
						
						WCF :: getTPL()->assign('value', $eventObj->postList->posts[$i]->temper);
						WCF :: getTPL()->assign('size', 'S');
						WCF :: getTPL()->assign('showTitle', true);
						
						$data[$eventObj->postList->posts[$i]->postID] = '<li><a>' . 
						WCF :: getTPL()->fetch('temperIcon')
						. '</a></li>';
					}

					WCF :: getTPL()->append('additionalSmallButtons', $data);
				}
				else
				{
					if ($className == 'PostEditForm')
						self :: $temper = $eventObj->post->temper;
					
					WCF :: getTPL()->assign('temper', self :: $temper);
					WCF :: getTPL()->assign('temperOptions', OptionUtil :: parseSelectOptions(self :: $temperOption['selectOptions']));
					WCF :: getTPL()->append('additionalSettings', WCF :: getTPL()->fetch('temperAddToPost'));
				}
			break;
		}
	}
}
?>